dnl --------------------------- Magic Numbers -------------------------------
dnl
dnl
dnl it should be done better using generic byte-reordering functions...
dnl


define({reorderbytes},
{ifelse(
    $1,$2,{cat(shift(shift($@)))},
    $1,reversechars($2),{cat(reverse(shift(shift($@))))},
)})

define({Magic_Number_},Hexnumber(reorderbytes(1234,__BYTE_ORDER,$4,$3,$2,$1)))

define(MAGIC_GOOSE,		Magic_Number_(E7,BD,99,20))
define(MAGIC_PtbOSL,		Magic_Number_(90,16,DF,64))
define(MAGIC_OSLi386,		Magic_Number_(6F,B2,24,18))
define(MAGIC_LxAPI,		Magic_Number_(0C,1E,40,49))
define(MAGIC_PC_API,		Magic_Number_(70,FC,53,00))
define(MAGIC_MARKER,		Magic_Number_(DE,AD,BE,EF))



forget({
## Here is for little endian machines
## how is it with byte order ? I mean, I assumed little endian (386 like)
## was used here; else, all longs must be byte-reordered... :(
0	long		0x2099BDE7	GOOSE file, little endian
0	long		0xE7BD9920	GOOSE file, big endian
0	long		0x64DF1690	Portable OSL code, little endian
0	long		0x9016DF64	Portable OSL code, big endian
0	long		0x1824B26F	i386 OSL code
0	long		0x49401E0C	Linux API for MOOSE
0	long		0x5300FC70	PC API for MOOSE


## Here is for big endian machines
## how is it with byte order ? I mean, I assumed little endian (386 like)
## was used here; else, all longs must be byte-reordered... :(
0	long		0x2099BDE7	GOOSE file, big endian
0	long		0xE7BD9920	GOOSE file, little endian
0	long		0x64DF1690	Portable OSL code, big endian
0	long		0x9016DF64	Portable OSL code, little endian
0	long		0x6FB22418	i386 OSL code
0	long		0x0C1E4049	Linux API for MOOSE
0	long		0x70FC5300	PC API for MOOSE


#### Here is the origin of these magic numbers:

MAGIC_GOOSE		=	0x2099BDE7
little endian	P	E	S	O	O	G
       00	10000	01001	10011	01111	01111	00111
5 bit code for 'GOOSE' big-endian,
5 bit code for P (portable)
two clear bits.


MAGIC_GOOSE_64		=	0x6099BDE7
little-endian	P	E	S	O	O	G
      01	10000	01001	10011	01111	01111	00111
5 bit code for 'GOOSE' little-endian,
5 bit code for P (portable)
clear bit & set bit.
This 32 bit value is followed (or preceded on big endian systems)
by '64b;' or '128b'


MAGIC_PtbOSL		=	0x64DF1690
; little-endian	L	S	O	b	t	P
;       	01100	10011	01111	100010	110100	10000
; Portable OSL


MAGIC_OSLi386		=	0x1824B26F
; little-endian	386	i	L	S	O
;       00  0110000010	01001	01100	10011	01111
; 5 bit code for 'OSL' little-endian,
; 5 bit code for i, 10-bit code for 386
; two clear bits.


MAGIC_LxAPI		=	0x49401E0C
; little endian	+-	I	P	A	x	L
;		01	001001	010000	000001	111000	001100
; 6 bit code for 'LxAPI--' little-endian


MAGIC_PC_API		=	0x5300FC70
; little endian	+-	I	P	A	-	C	P
;		01	01001	10000	00001	11111	00011	10000
; 5 bit code for 'LxAPI--' little-endian


MAGIC_MARKER		=	0x0EFBEADDE	; bytes: DEADBEEF
})
